;********************PROGRAM PRO FAZOVE RIZENI**********************
		
	PERIODA	BIT	1
	POCPR	EQU	R7
	JAS	EQU	21
	
	CAS	EQU 	16
	POC	EQU 	17
	PPV	EQU 	18
	PVL	EQU 	19
	RPV	EQU 	20
	
	ZALOHA	EQU	22
	POM	BIT	2 
;*******************************************************************
	JMP 	INIT
	ORG 	0003H
	JMP 	EXT0	;PRUCHOD NULOU
	ORG 	000BH
	JMP 	CT0	;100uS PRO JAS 
	ORG 	0013H
	JMP 	EXT1	;KOSTKA
	ORG 	001BH
	JMP 	INT50	;CT1 - 50uS PRO DO
	ORG 	0100H
;******************************************************************
INIT:	CLR	PERIODA
	MOV	TMOD,#00100010B
	MOV	TCON,#01010101B
	MOV	IE,#10001111B
	MOV	IP,#00001000B
	MOV	TH1,#0CDH
	MOV	TL1,TH1
	
	MOV	TH0,#09CH
	MOV	TL0,TH0
	
	CLR	TR0
	CLR	TR1
	
	
	MOV 	PVL,#255
	MOV 	CAS,#0
	MOV	POC,#0
	MOV 	RPV,#0
	MOV 	PPV,#0
		
	MOV	JAS,#50
	MOV	POCPR,#0
	
	CLR	POM
;***********************************************************

ZAC:	MOV 	R5,PVL
	CJNE 	R5,#255,PLUS
	JMP 	ZAC
	
PLUS:	CJNE 	R5,#10100100B,MINUS
	MOV	A,JAS
	CJNE 	A,#36,PLUS1
	JMP 	KONT
	
PLUS1:	DEC 	JAS
	JMP 	KONT
	
MINUS:	CJNE 	R5,#00000110B,OFF
	MOV	A,JAS
	CJNE	A,#100,MINUS1
	JMP 	KONT
	
MINUS1:	INC 	JAS
	JMP 	KONT

OFF:	CJNE	R5,#10011101B,ON
	JB	POM,KONT
	MOV	ZALOHA,JAS
	MOV	JAS,#100	
	SETB	POM
	JMP	KONT
	
ON:	CJNE	R5,#01001101B,KONT
	JNB	POM,KONT
	MOV	JAS,ZALOHA
	CLR	POM
	JMP	KONT	
	
KONT:	MOV 	PVL,#255
	JMP 	ZAC			

;***********************************************************

EXT0:	SETB	TR0
	CLR	PERIODA
	MOV	TH0,#9CH
	MOV	TL0,TH0
	MOV	POCPR,#0
	RETI


CT0:	PUSH	ACC
	PUSH	PSW
	JB	PERIODA,DRUHA
	MOV	A,POCPR
	CJNE	A,JAS,KONEC

PRVNI:	CLR	P1.7
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	SETB	P1.7
	SETB	PERIODA
	MOV	POCPR,#0
	JMP	KONEC2

DRUHA:	MOV	A,POCPR
	CJNE	A,100,KONEC
	CLR	P1.7
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	NOP
	SETB	P1.7
	CLR	PERIODA
	JMP	KONEC2
	
KONEC:	INC	POCPR
	POP	PSW
	POP	ACC
	RETI
	
KONEC2:	POP	PSW
	POP	ACC
	RETI	
;**************************************************************

INT50:	PUSH ACC
	INC CAS
	MOV A,CAS
	CJNE A,#255,BIT_OK
	CLR TR1	
	MOV POC,#0
	MOV CAS,#0

BIT_OK:	POP ACC
	RETI

;***********************************************************

EXT1:	PUSH 	ACC
	MOV 	DPTR,#TAB1
	MOV 	A,CAS
	MOVC	A,@A+DPTR
	MOV 	R1,A
	MOV 	R0,POC
	CJNE	R0,#0,DALSI		
	SETB 	TR1
	JMP 	ZV_POC
	
DALSI:	CJNE 	R0,#1,CTI_B
	CJNE 	R1,#3,ZAKMIT
	JMP 	ZV_POC
	
ZAKMIT:	CJNE 	R1,#2,ERR
	JMP 	KINT
	
CTI_B:	CJNE 	R0,#12,TEST1
	CLR 	TR1
	MOV 	POC,#0
	MOV 	CAS,#0
	MOV 	PVL,RPV
	JMP 	KINT
		
TEST1:	CJNE 	R1,#1,TEST0
	MOV 	A,PPV
	RL 	A
	SETB ACC.0
	MOV PPV,A
	JMP PREPIS
	
TEST0:	CJNE R1,#0,ZAKMIT
	MOV A,PPV
	RL A					
	CLR ACC.0
	MOV PPV,A
	JMP PREPIS
	
PREPIS:	CJNE R0,#9,ZV_POC
	MOV RPV,PPV
	JMP ZV_POC
	
ERR:	MOV POC,#0
	MOV CAS,#0		
	CLR TR1
	JMP KINT
	
ZV_POC:	INC POC
	MOV CAS,#0
	
KINT:	POP ACC
	RETI		
	
	
	
	
TAB1:	DB   2;0
	DB   2;1
	DB   2;2
	DB 255;3
	DB 255
	DB 255 
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255;10
	DB 255	
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255;20
	DB 255
	DB   0
	DB   0
	DB   0
	DB   0  
	DB 255
	DB 255 
	DB 255
	DB 255
	DB 255;30
	DB 255
	DB 255
	DB 255
	DB   1
	DB   1
	DB   1
	DB   1
	DB 255
	DB 255
	DB 255;40
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255;50
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255
	DB 255 
	DB   3
	DB   3;60
	DB   3
	DB   3
	DB   3
	DB 255
	DB 255
	DB 255 



	
END


		